/*
 * This header declares the LinkedIntList class and its members.
 * A LinkedIntList encapsulates the list methods from previous lectures
 * into an object that keeps track of the front of the list.
 * See LinkedIntList.cpp for the implementation of the methods.
 */

#ifndef _linkedintlist_h
#define _linkedintlist_h

#include "listnode.h"
#include <iostream>
using namespace std;

class LinkedIntList {
public:
    LinkedIntList();   // constructor
    ~LinkedIntList();  // destructor (frees memory)

    // member functions (methods)
    void addBack(int value);
    void addFront(int value);
    int get(int index) const;
    void insert(int index, int value);
    bool isEmpty() const;
    void removeBack();
    void removeFront();
    void remove(int index);
    void set(int index, int value);
    int size() const;

    // Prints out the elements of the list, separated by commas.
    // listing this operator as a "friend" means that it can access the
    // private member variables of the list (front).
    friend ostream& operator <<(ostream& out, LinkedIntList& list);

private:
    // member variables (instance variables / fields)
    ListNode* _front;   // null if empty
};

#endif
