/*
 * This program tests some of our LinkedList class functions.
 *
 */

#include <iostream>
#include "console.h"
#include "linkedintlist.h"
#include "testing/SimpleTest.h"
using namespace std;



int main()
{
    if (runSimpleTests(SELECTED_TESTS)) {
        return 0;
    }
    cout << "All done, exiting" << endl;
    return 0;
}



/* * * * * * Test Cases * * * * * */

PROVIDED_TEST("Basic test case for list") {
    // front -> 42 -> 17 -> -3 -> 9 /
    LinkedIntList list;
    list.addBack(42);
    list.addBack(17);
    list.addBack(-3);
    list.addBack(9);

    EXPECT_EQUAL(list.size(), 4);
    EXPECT_EQUAL(list.get(0), 42);
    EXPECT_EQUAL(list.get(1), 17);
    EXPECT_EQUAL(list.get(2), 3);
    EXPECT_EQUAL(list.get(3), 9);

    // insert 88 at front of list
    list.addFront(88);

    EXPECT_EQUAL(list.size(), 5);
    EXPECT_EQUAL(list.get(0), 88);

    list.addBack(777);
    cout << list << endl;

    EXPECT_EQUAL(list.size(), 6);
    EXPECT_EQUAL(list.get(5), 777);

    list.removeFront();

    EXPECT_EQUAL(list.size(), 5);
    EXPECT_EQUAL(list.get(0), 42);

    list.removeBack();

    EXPECT_EQUAL(list.size(), 4);
    EXPECT_EQUAL(list.get(0), 9);
}
